当我在 leetcode 上解决问题时,它说在给定的按非递减顺序排序的整数数组 nums 中,找到给定目标值的开始和结束位置。因此不可能用简单的二进制 Sarch 来返回数组中目标元素的开始和结束,因为它只返回找到第一个目标元素的索引,该元素可以是该元素的第一个、结尾或中间的任何内容。所以我们使用 Double Binary Scarch ,具体方法如下...
第一次二分查找:
第二次二分查找:
返回结果:
时间复杂度:
空间复杂度:
class Solution { public int[] searchRange(int[] nums, int target) { int ei = nums.length - 1; int si = 0; int[] res = {-1, -1}; // Initialize result array // First binary search to find the last occurrence while (si <= ei) { int mid = si + (ei - si) / 2; if (target < nums[mid]) { ei = mid - 1; } else if (target > nums[mid]) { si = mid + 1; } else { res[1] = mid; // Update end index si = mid + 1; // Search in the right half } } // Reset the pointers for the second binary search si = 0; ei = nums.length - 1; // Second binary search to find the first occurrence while (si <= ei) { int mid = si + (ei - si) / 2; if (target < nums[mid]) { ei = mid - 1; } else if (target > nums[mid]) { si = mid + 1; } else { res[0] = mid; // Update start index ei = mid - 1; // Search in the left half } } return res; // Return the result array } }
以上是如何使用高级二进制搜索?的详细内容。更多信息请关注PHP中文网其他相关文章!